// #####################################################################

// Beep subsystem

#include "beep.h"
#include "menu.h"

#include <Arduino.h>

#define BEEP_PIN  3

bool beep_enabled;
int beep_duration = 0;

const PROGMEM struct MENU_ENTRY menu_beep[] =
{
  { { .text = "Beep enable" }, .type = MENU_BOOL, .data = &beep_enabled, .user_data = 0, .extra = NULL },
  { { .text = "" }, .type = MENU_NOTHING }
};

extern unsigned long current_millis;
bool b_beep_initialized = false;
unsigned long beep_routine_millis = 50;

// #####################################################################

void beep( int duration )
{
  beep_duration = duration;
}

// #####################################################################

void beep_routine( )
{
  // check timer
  if( current_millis < beep_routine_millis )
    return;
  beep_routine_millis = current_millis + 10;

  if( b_beep_initialized == false )
  {
    pinMode( BEEP_PIN, OUTPUT );
    
    Serial.println(F("[Beep] Beep subsystem initialized."));
    b_beep_initialized = true;
  }
  else
  {
    if( beep_enabled == true )
    {
      if( beep_duration > 0 )
      {
        beep_duration -= 10;
        digitalWrite( BEEP_PIN, HIGH );
      }
      else
      {
        digitalWrite( BEEP_PIN, LOW );
      }
    }
    else
    {
      beep_duration = 0;
    }
  }
}

// #####################################################################