// #####################################################################

#include <Arduino.h>

#include "gpio.h"
#include "lcd.h"

// Serial speed: 115200

bool b_serial_wait = false;         // wait for "Port Monitor" connection

extern unsigned long current_millis;
bool b_serial_initialized = false;
unsigned long serial_routine_millis = 20;

// #####################################################################

void serial_routine( )
{
  // check timer
  if( current_millis < serial_routine_millis )
    return;
  serial_routine_millis = current_millis + 20;

  if( b_serial_initialized == false )
  {
    // Log and debug information channel
    Serial.begin( 115200 );

    if( b_serial_wait == true )
    {
      while( !Serial )
      {
        ; // wait for serial port to connect. Needed for native USB port only
      }
    }

    Serial.println(F("[Serial] Serial communication initialized at 115200 speed."));

    b_serial_initialized = true;
  }
  else
  {
    // Read user input
    if( Serial.available( ) != 0 )
    {
      char ch = Serial.read( );

      if( b_gpio_initialized == true && ch == 'H' )
      {
        PCF.write( 12, HIGH );
        int x = PCF.read16( );
      }
      else if ( b_gpio_initialized == true && ch == 'L' )
      {
        PCF.write( 12, LOW );
        int x = PCF.read16( );
      }
      else if ( b_gpio_initialized == true && ch == 'P' )
      {
        int x = PCF.readButton16( );
        Serial.print( F("[Serial] GPIO Read: ") );
        Serial.println( x, BIN );
      }
      else if ( b_gpio_initialized == true && ch == 't' )
      {
        Serial.println( display_state );
        Serial.println( display_buffer );
      }
    }
  }
}

// #####################################################################
