// #####################################################################

// Tunnel subsystem

#include <SPI.h>
#include <WiFiNINA.h> //Include this instead of WiFi101.h as needed
#include <WiFiUdp.h>

#include "wifi.h"

bool b_tunnel_enabled = false;

// Initialize the Ethernet client library
// with the IP address and port of the server
// that you want to connect to (port 80 is default for HTTP):
WiFiClient tunnel_client;

char tunnel_server[32] = "pik-pik.ee";    // name address for tunnel server

extern unsigned long current_millis;
bool b_tunnel_initialized = false;
unsigned long tunnel_routine_millis = 10000;

// #####################################################################

void tunnel_routine( )
{
  // check timer
  if( current_millis < tunnel_routine_millis )
    return;
  if( b_tunnel_initialized == true )
    tunnel_routine_millis = current_millis + 1 * 1000;
  else
    tunnel_routine_millis = current_millis + 60 * 1000;
  

  if( b_tunnel_initialized == false && b_tunnel_enabled == true && wifi_status == WL_CONNECTED )
  {
    Serial.println( F( "[Tunnel] Connecting to the tunnel..." ) );
    if( tunnel_client.connect( tunnel_server, 2000 ) )
    {
      Serial.println( F( "[Tunnel] Tunnel initialized succesfully." ) );
      b_tunnel_initialized = true;
    }
    else
    {
      Serial.println( F( "[Tunnel] Failed to connect to the tunnel." ) );
    }
  }
  else if( b_tunnel_initialized == true && b_tunnel_enabled == true )
  {
    // if there are incoming bytes available
    // from the server, read them and print them:
    if( tunnel_client.available( ) )
    {
      char c = tunnel_client.read( );
      Serial.print( F( "[Tunnel] Incomming data: " ) );
      Serial.println( c );
    }

    tunnel_client.print( "test\n" );

    // if the server's disconnected, stop the client:
    if( !tunnel_client.connected( ) || wifi_status != WL_CONNECTED )
    {
      Serial.println( F( "[Tunnel] Tunnel disconnected." ) );
      b_tunnel_initialized = false;
      tunnel_client.stop( );
    }
  }
}

// #####################################################################