// #####################################################################

// Watchdog subsystem

#include "watchdog.h"
#include "menu.h"

WDTZero watchdog; // Define WDT  

bool watchdog_enabled = false;

void restart( struct MENU_ENTRY *menu_entry );

const PROGMEM struct MENU_ENTRY menu_watchdog[] =
{
  { { .text = "WDT Enable" }, .type = MENU_BOOL, .data = &watchdog_enabled, .user_data = 0, .extra = NULL },
  { { .text = "" }, .type = MENU_NOTHING }
};

extern unsigned long current_millis;
bool b_watchdog_initialized = false;
unsigned long watchdog_routine_millis = 1000;

// #####################################################################

void watchdog_shutdown( )
{
  Serial.println(F("[Watchdog] Restarting the system."));
}

void watchdog_routine( )
{
  // check timer
  if( current_millis < watchdog_routine_millis )
    return;
  watchdog_routine_millis = current_millis + 1000;

  if( watchdog_enabled == false )
  {
    watchdog.setup( WDT_OFF );
    return;
  }

  if( b_watchdog_initialized == false )
  {
    watchdog.attachShutdown( watchdog_shutdown );
    watchdog.setup( WDT_SOFTCYCLE16S );  // initialize WDT-softcounter refesh cycle on 32sec interval
    //watchdog.setup( WDT_HARDCYCLE16S );
 
    Serial.println(F("[Watchdog] Watchdog subsystem initialized."));
    b_watchdog_initialized = true;
  }
  else
  {
    watchdog.clear( );
  }
}

// #####################################################################