// #####################################################################

// WiFi settings

#include <SPI.h>
#include <WiFiNINA.h> //Include this instead of WiFi101.h as needed
#include <WiFiUdp.h>

#define WIFI_MAX_SSID_LENGTH      32
#define WIFI_MAX_PASS_LENGTH      64

#define WIFI_SAVED_NETWORKS_MAX   10

extern char wifi_firmware[8];
extern char wifi_mac[20];
extern char wifi_local_ip[24];
extern char wifi_connected_rssi[16];

extern int wifi_status;
extern bool b_wifi_autoconnect;

struct WIFI_NETWORK
{
  char ssid[WIFI_MAX_SSID_LENGTH+1];
  char pass[WIFI_MAX_PASS_LENGTH+1];
};

extern struct WIFI_NETWORK wifi_networks[WIFI_SAVED_NETWORKS_MAX];

extern struct MENU_ENTRY menu_wifi[];

extern unsigned long wifi_routine_millis;
extern unsigned long wifi_connect_millis;

void wifi_routine( );

void printWiFiStatus( );

// #####################################################################
